PROGRAM Test_Lib_For_Pascal;

USES crt,
     ml8bib,
     ml8type,
     m048_lib;

CONST
  MODUL   = 3;
  CHANNEL = 7;

PROCEDURE gethex(val: byte; var hex:string);

VAR i, j: byte;

BEGIN

 hex[0] := '2';                        (* length of string                 *)

 j := val DIV 16;
 i := val MOD 16;

 IF(i < 10) THEN
  hex[2] := chr(i + 48)
 ELSE
  BEGIN
   i := i - 10;
   hex[2] := chr(i + 65);
  END;

 IF(j < 10) THEN
  hex[1] := chr(j + 48)
 ELSE
  BEGIN
   j := j - 10;
   hex[1] := chr(j + 65);
  END;
END;


PROCEDURE errorhandler;
BEGIN
END;


VAR
   baudrate, quartz : longint;
   var error        : longint;
   var reg, used_reg: byte;
   var used_clkmode : byte;
   var timeconst    : word;
   basis, err       : real;
   x, y, postdiv    : byte;
   asc              : string;
   osname           : str80;
   use_brg          : byte;


BEGIN
 osname := 'ROM';
 quartz := 25000000;

 clrscr;
 writeln('------------- M-COM-8 Testprogam (DOS/Pascal) --------------');

 ml8_bib_startup($100);
 ml8_reset(0, $380, 0, 7, 0, @errorhandler, osname, 1000);
 m048_bib_startup(MODUL);

 REPEAT
   BEGIN
    writeln;
    write('Baudrate (0 = Break) : ');
    readln(baudrate);
    writeln('------------------------------------------------------------');
    IF(baudrate > 0) THEN
    BEGIN
     m048_baudrate_calc(baudrate, quartz, error, reg, used_clkmode, timeconst, use_brg);
     m048_set_channel(MODUL, CHANNEL, baudrate, 1, $56, 0, 0, 8, 1, 0, error, used_clkmode);

     reg := ml8_in8_port($60 + MODUL * $20 + $12);

     ml8_out8_port($60 + MODUL * $20 + $0C, 12);
     timeconst := ml8_in8_port($60 + MODUL * $20 + $0C);
     ml8_out8_port($60 + MODUL * $20 + $0C, 13);
     timeconst := timeconst + 256 * (ml8_in8_port($60 + MODUL * $20 + $0C));

     used_reg := ml8_in8_port($60 + MODUL * $20 + $12);

     IF(use_brg >= 1) THEN
       basis := (timeconst + 2.0) * 2.0 * used_clkmode * baudrate
     ELSE
       basis := used_clkmode * baudrate;

     err := error / basis;

     x := reg AND $1F;
     y := (reg AND $20) SHR 5;
     postdiv := 5 - ((reg AND $C0) SHR 6);

     writeln('Baudrate          :', baudrate:7, ' Baud');
     writeln('Quartz            :', (quartz / 1000000):7:2, ' MHz');

     gethex(reg, asc);

     writeln('Baseclk-Register  :    $', asc);
     IF(reg <> used_reg) THEN writeln('ERROR !');
     writeln('SCC Clockmode     :    /', used_clkmode:2);
     writeln('SCC Timeconst     :', timeconst:7);
     writeln('Baudrate-Error    : ', (err * 100.0):6:4, ' %');
     writeln;
     writeln('Channel ', CHANNEL, ' set to ', baudrate, ' Baud.');
     IF(use_brg = 0) THEN
       BEGIN
         writeln('Do not');
       END;
     writeln('Use Baudrategenerator');
     writeln;

     writeln('------------------------------------------------------------');

    END;
   END;
 UNTIL(baudrate = 0);
END.


