#include <stdio.h>
#include <windows.h>
#include "c:\sorcus\ml8\dos\c\ml8bib.h"
#include "..\..\..\..\c\m048_lib.h"


#pragma argsused


#define MODUL   3
#define CHANNEL 7


void errorhandler(void);

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
 long baudrate, quartz, error;
 unsigned short timeconst;
 unsigned char  clkmode, reg, x, y, postdiv, used_clkmode, used_reg, use_brg;
 float err, basis;

_InitEasyWin();


 ml8_bib_startup(LANGUAGE_C);
 ml8_reset(0, 0x380, 0, 7, 0, *errorhandler, "ROM", 1000);
 
 ml8_out8_port(0x300 + MODUL * 0x100 + 0x12, 0x00); /* Basereg 1 = 0 */

 quartz = 25000000;

 m048_bib_startup(MODUL);

 printf("\n\r------------- M-COM-8 Testprogram (Windows/C) -----------------");


 do{
	 printf("\n\r Baudrate (0 = Break): ");
	 scanf("%ld", &baudrate);
	 printf("\n\r----------------------------------------------------------------");
	 if(baudrate > 0)
      {

		 m048_baudrate_calc(baudrate, quartz, &error, &reg, &clkmode, &timeconst, &use_brg);


		 if(use_brg >= 1) basis = ((float)timeconst + 2.0) * 2.0 *
						(float)clkmode * (float)baudrate;
		 else basis = (float)clkmode * (float)baudrate;

		 err = (float)error / basis;
		 x = reg & 0x1F;
		 y = (reg & 0x20) >> 5;
		 postdiv = 5 - ((reg & 0xC0) >> 6);


		 printf("\n Baudrate   : %8ld Baud", baudrate);
		 printf("\n Quartz     :    %5.2f MHz", (float)quartz / 1000000.0);
		 printf("\n Error      :    %5.2f %", err * 100.0);
		 printf("\n Basereg    :       %2X", reg);
		 printf("\n  -       x :       %2i", x);
		 printf("\n  -       y :       %2i", y);
		 printf("\n  - postdiv :       /%1i", postdiv);

		 printf("\n Clkmode    :      /%i", clkmode);
		 printf("\n Timeconst  :  %7i", timeconst);
		 if(use_brg == 0) printf("\nDon't");
		 printf("\nUse Baudrategenerator");


		 m048_set_channel(MODUL, CHANNEL, baudrate, 1,         /* set channel for baudrate */
								0x56, 0x00, 0x00,
								8, 1, 0, &error, &used_clkmode);

																				 /* check if settings ok */

		 used_reg = ml8_in8_port(0x300 + MODUL * 0x100 + 0x12);

		 if(used_reg != reg)
			{
			 printf("\n\r ERROR");
			 return;
			}
		 if(used_clkmode != clkmode)
			{
			 printf("\n\r ERROR");
			 return;
			}

		 printf("\n\r Channel %i set to Baudrate %7.2f Baud !", CHANNEL, (float)baudrate);
		 printf("\n\r----------------------------------------------------------------");
		}
	}while(baudrate > 0);

 return;
}


void errorhandler()
{
}
