{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-COM-8                 **)
(**                                                                       **)
(**                             Version 1.B.                              **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "Pascal"                      **)
(**                                                                       **)
(**             Last change      : 10.12.1995                             **)
(**                                                                       **)
(**                         Author : A.H.                                 **)
(**                         Status : ----                                 **)
(**                                                                       **)
(**                                                                       **)
(** Special comments:                                                     **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0.              **)
(**                                                                       **)
(** No parameters are checked.                                            **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1995                           **)
(**                                                                       **)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*)

unit m048_lib;
interface

uses
{$IFDEF ML8}
	{$IFDEF Windows}
		wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
	{$ELSE}
	       {$IFDEF ML8RT}
		       ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
	       {$ELSE}
		       ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
	       {$ENDIF}
	{$ENDIF}
{$ELSE}
	{$IFDEF Windows}
		wml4bib,wml4deb;    (* Include library for MODULAR-4/Z80 under WINDOWS *)
	{$ELSE}
		ml4bib,ml4deb;      (* Include library for MODULAR-4/Z80 under DOS *)
	{$ENDIF}
{$ENDIF}

{$IFDEF DLL}
const
     M048DLL = 'M048_LIB';
{$ENDIF}
const
 M048_CHANNELSEL        = $10;         (* Channel Select                   *)
 M048_CLKSEL            = $11;         (* Clock Select Register            *)
 M048_BASECLK1          = $12;         (* Base-Clock 1 Register            *)
 M048_BASECLK2          = $13;         (* Base-Clock 1 Register            *)
 M048_BASECLK3          = $14;         (* Base-Clock 1 Register            *)
 M048_BASECLK4          = $15;         (* Base-Clock 1 Register            *)
 M048_INTSEL            = $16;         (* Interrupt Select                 *)
 M048_PCLKSEL           = $17;         (* PCLK Select                      *)
 M048_READ_FPGA_VERSION = $18;         (* Read FPGA-Version (8Bit)         *)


(* Init module library *)
procedure m048_bib_startup(micro_slot: byte);

(* Reset SCC *)
procedure m048_scc_reset(micro_slot, sccnum: byte);

(* Initialize SCC-Channel *)
function m048_init_scc(micro_slot, channel, mode, int_mode, int_x_mode: byte;
		       timeconst: word; use_brg, clkmode, databits, stopbits,
		       parity_type: byte): byte;

(* Read SCC-TBE Bit *)
function m048_scc_tbe(micro_slot, channel: byte): byte;

(* Read SCC-RBF Bit *)
function m048_scc_rbf(micro_slot, channel: byte): byte;

(* Read SCC-CTS Bit *)
function m048_scc_cts(micro_slot, channel: byte): byte;

(* Send Character *)
function m048_transmit_scc_character(micro_slot, channel,
				     character: byte): byte;

(* Receive Character *)
function m048_receive_scc_character(micro_slot, channel: byte;
				    var data: byte): byte;

(* Set/Clear SCC-RTS *)
procedure m048_set_rts(micro_slot, channel, rts: byte);

(* get interrupt vector, rr0, rr1 & rr3 (pending) *)
procedure m048_scc_intak(micro_slot: byte;
			 var int_vector, rr0, rr1, rr3: byte);

(* calculate baudrate adjustments *)
procedure m048_baudrate_calc(baudrate, quartz: longint; var error: longint;
			     var reg, clk_mode: byte; var timeconst: word; var use_brg: byte);

procedure m048_check(quartz, base: longint; clk_mode: byte;
		     timeconst: word; use_reg: byte; var bestx, besty, bestclk_mode: byte;
		     var besttimeconst: word; var bestuse_brg, bestpostdiv: byte; var besterror: longint);

function m048_set_channel(micro_slot, channel: byte; baudrate: longint;
			  flag, scc_mode, scc_int_mode, scc_int_x_mode,
			  scc_databits, scc_stopbits, scc_parity_type: byte;
			  var b_error: longint; var used_clkmode: byte): byte;


implementation

{$IFNDEF DLL}           (* If no DLL is generated, a .OBj file has to be included *)

{$L m048_lib.obj}

{$ENDIF}



(* Init module library *)
procedure m048_bib_startup(micro_slot: byte);
	  external {$IFDEF DLL} M048DLL {$ENDIF};


(* Reset SCC *)
procedure m048_scc_reset(micro_slot, sccnum: byte);
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Initialize SCC-Channel *)
function m048_init_scc(micro_slot, channel, mode, int_mode, int_x_mode: byte;
		       timeconst: word; use_brg: byte; clkmode, databits, stopbits,
		       parity_type: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Read SCC-TBE Bit *)
function m048_scc_tbe(micro_slot, channel: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Read SCC-RBF Bit *)
function m048_scc_rbf(micro_slot, channel: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Read SCC-CTS Bit *)
function m048_scc_cts(micro_slot, channel: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Send Character *)
function m048_transmit_scc_character(micro_slot, channel,
				     character: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Receive Character *)
function m048_receive_scc_character(micro_slot, channel: byte;
				    var data: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* Set/Clear SCC-RTS *)
procedure m048_set_rts(micro_slot, channel, rts: byte);
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* get interrupt vector, rr0, rr1 & rr3 (pending) *)
procedure m048_scc_intak(micro_slot: byte;
			 var int_vector, rr0, rr1, rr3: byte);
	  external {$IFDEF DLL} M048DLL {$ENDIF};

(* calculate baudrate adjustments *)
procedure m048_baudrate_calc(baudrate, quartz: longint; var error: longint;
			     var reg, clk_mode: byte; var timeconst: word; var use_brg: byte);
	  external {$IFDEF DLL} M048DLL {$ENDIF};

procedure m048_check(quartz, base: longint; clk_mode: byte;
		     timeconst: word; use_reg: byte; var bestx, besty, bestclk_mode: byte;
		     var besttimeconst: word; var bestuse_brg, bestpostdiv: byte; var besterror: longint);
	  external {$IFDEF DLL} M048DLL {$ENDIF};


function m048_set_channel(micro_slot, channel: byte; baudrate: longint;
			  flag, scc_mode, scc_int_mode, scc_int_x_mode,
			  scc_databits, scc_stopbits, scc_parity_type: byte;
			  var b_error: longint; var used_clkmode: byte): byte;
	  external {$IFDEF DLL} M048DLL {$ENDIF};




begin
end.
